searchNodes=[{"doc":"GenServer which is responsible for managing client state and sending requests to the Analytics API. The plug SauceAnalytics.Plug.MaintainSession is required to run before any function invocations in this module because it depends on keys created in Plug.Session . Options :app_info - SauceAnalytics.AppInfo which idenfies the app on the analytics API, ensure the name of the app is unique. Required. :api_url - The URL of the Sauce Analytics API which will be used for visit and event requests. Required. :session_id_name - The name of the key which will be used in the Plug.Session for storing the session's id. Defaults to :sauce_analytics_session_id . :revive_session_name - The name of the key which will be used in the Plug.Session and socket.assigns for storing the SauceAnalytics.ReviveSession struct. Defaults to :sauce_analytics_session_revive_info . :revive_session_cookie_name - The name of the cookie used for storing the SauceAnalytics.ReviveSession struct. Defaults to &quot;sauce_analytics_session_revive_info&quot; .","ref":"SauceAnalytics.html","title":"SauceAnalytics","type":"module"},{"doc":"Given a conn , The uid in the store is updated with given user_id and the uid in revive_session stored in the Plug.Session is updated with the given user_id . user_id can be nil.","ref":"SauceAnalytics.html#assign_user/2","title":"SauceAnalytics.assign_user/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SauceAnalytics.html#child_spec/1","title":"SauceAnalytics.child_spec/1","type":"function"},{"doc":"Returns the state/configuration of the SauceAnalytics GenServer.","ref":"SauceAnalytics.html#get_state/0","title":"SauceAnalytics.get_state/0","type":"function"},{"doc":"Starts the SauceAnalytics GenServer with the given opts Use this in your application supervision tree.","ref":"SauceAnalytics.html#start_link/1","title":"SauceAnalytics.start_link/1","type":"function"},{"doc":"Given a conn or a socket with session information. An event request is sent to the Analytics API. Example Originally intended for Ember, the arguments would be: name - A unique string to represent the event (e.g &quot;users.search&quot; ) title -A unique string to represent the route the user has visited (e.g &quot;internal.list.users&quot; ) data - A JSON object containing any data related to the event (e.g {&quot;term&quot;: &quot;John&quot;, results: [...]} ) However there is no concept of routes in Phoenix so this would be sufficient: name - A unique string to represent the event (e.g &quot;users.search&quot; ) title - A full URL without query params (e.g &quot;/list/users&quot; ) data - A map with string keys containing any data related to the event (e.g %{&quot;term&quot; =&gt; &quot;John&quot;, &quot;results&quot; =&gt; [...] ) LiveView defmodule MyApp.Live.ListUsers do use MyApp , :live_view # required for any analytics calls in a LiveView on_mount ( SauceAnalytics.Live.SetupAssigns ) def mount ( ... ) , do : ... def handle_event ( &quot;search&quot; , data , socket ) do ... { :noreply , socket |&gt; SauceAnalytics . track_event ( &quot;/users/list&quot; , &quot;users.list.search&quot; , %{ &quot;count&quot; =&gt; length ( data . results ) , &quot;results&quot; =&gt; data . results } ) } end end","ref":"SauceAnalytics.html#track_event/4","title":"SauceAnalytics.track_event/4","type":"function"},{"doc":"Given a conn or a socket with session information. A visit request is sent to the Analytics API. Example Originally intended for Ember, the arguments would be: name - A full URL including route/query params (e.g. &quot;/list/users?sortBy=title&quot; ) title - A unique string to represent the route the user has visited (e.g. &quot;internal.list.users&quot; ) However there is no concept of routes in Phoenix so this would be sufficient: name - A full URL including query params (e.g &quot;/list/users?sortBy=title&quot; ) title - A full URL without query params (e.g &quot;/list/users&quot; )","ref":"SauceAnalytics.html#track_visit/3","title":"SauceAnalytics.track_visit/3","type":"function"},{"doc":"","ref":"SauceAnalytics.html#t:opts/0","title":"SauceAnalytics.opts/0","type":"type"},{"doc":"Information which identifies your app on the Sauce Analytics API. Fields :name - A unique string which represents the name of the app. :uid - A unique string which represents the user. :user_agent - The user agent of the client's web browser. :environment - A string which represents the application's environment.","ref":"SauceAnalytics.AppInfo.html","title":"SauceAnalytics.AppInfo","type":"module"},{"doc":"","ref":"SauceAnalytics.AppInfo.html#t:t/0","title":"SauceAnalytics.AppInfo.t/0","type":"type"},{"doc":"Responsible for parsing any SauceAnalytics.HTTP.Request and sending POST requests to the Sauce Analytics API. Uses HTTPoison as a backend for sending requests.","ref":"SauceAnalytics.HTTP.html","title":"SauceAnalytics.HTTP","type":"module"},{"doc":"Given the app_info , api_uri , and request . This sends a POST request to the appropriate endpoint based on the :type field in request . Returns {status, HTTPoison.Response{}} depending on the status of the response.","ref":"SauceAnalytics.HTTP.html#post/3","title":"SauceAnalytics.HTTP.post/3","type":"function"},{"doc":"","ref":"SauceAnalytics.HTTP.Request.html","title":"SauceAnalytics.HTTP.Request","type":"module"},{"doc":"","ref":"SauceAnalytics.HTTP.Request.html#t:request_types/0","title":"SauceAnalytics.HTTP.Request.request_types/0","type":"type"},{"doc":"","ref":"SauceAnalytics.HTTP.Request.html#t:t/0","title":"SauceAnalytics.HTTP.Request.t/0","type":"type"},{"doc":"Callback which is invoked on the Phoenix.LiveView 's mount using on_mount/4 . Required when invoked SauceAnalytics functions in a Phoenix.LiveView . Sets up an assign which holds a SauceAnalytics.ReviveSession , the name of this assign is configured in the opts of SauceAnalytics .","ref":"SauceAnalytics.Live.SetupAssigns.html","title":"SauceAnalytics.Live.SetupAssigns","type":"module"},{"doc":"","ref":"SauceAnalytics.Live.SetupAssigns.html#on_mount/4","title":"SauceAnalytics.Live.SetupAssigns.on_mount/4","type":"function"},{"doc":"Plug responsible for creating entries in Plug.Session for clients. Required for SauceAnalytics to function properly. Two entries are created, the session_id entry and the revive_session entry. The names of these entries are configured in the opts of the SauceAnalytics GenServer.","ref":"SauceAnalytics.Plug.MaintainSession.html","title":"SauceAnalytics.Plug.MaintainSession","type":"module"},{"doc":"","ref":"SauceAnalytics.Plug.MaintainSession.html#call/2","title":"SauceAnalytics.Plug.MaintainSession.call/2","type":"function"},{"doc":"","ref":"SauceAnalytics.Plug.MaintainSession.html#init/1","title":"SauceAnalytics.Plug.MaintainSession.init/1","type":"function"},{"doc":"This struct contains the minimum amount of information that can be used to revive a session. This struct exists to handle cases where the session expires after inactivity or if the session in the store is lost from an event such as a server deploy/restart. Fields :sid - The id of the session. :uid - The id of the user. Can be nil. :user_agent - The user agent of the client's web browser. :client_ip - The IP address of the client.","ref":"SauceAnalytics.ReviveSession.html","title":"SauceAnalytics.ReviveSession","type":"module"},{"doc":"","ref":"SauceAnalytics.ReviveSession.html#t:t/0","title":"SauceAnalytics.ReviveSession.t/0","type":"type"},{"doc":"The state of the SauceAnalytics GenServer","ref":"SauceAnalytics.State.html","title":"SauceAnalytics.State","type":"module"},{"doc":"","ref":"SauceAnalytics.State.html#t:t/0","title":"SauceAnalytics.State.t/0","type":"type"},{"doc":"Session store for analytics information, uses an ETS as a backend for the data. Options :table_name - The name of the table that the ETS will use. Defaults to :sauce_analytic_session_table :session_max_age - The number of seconds before a session in the Store is considered expired. Defaults to 3600 (1 hour) :clean_interval - The number of seconds that specify the period of time between each clean up of expired sessions. Defaults to 5400 (1.5 hours)","ref":"SauceAnalytics.Store.html","title":"SauceAnalytics.Store","type":"module"},{"doc":"Assigns a user to a session in the Store.","ref":"SauceAnalytics.Store.html#assign_user/2","title":"SauceAnalytics.Store.assign_user/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SauceAnalytics.Store.html#child_spec/1","title":"SauceAnalytics.Store.child_spec/1","type":"function"},{"doc":"Returns the state/configuration of the SauceAnalytics.Store GenServer.","ref":"SauceAnalytics.Store.html#get_state/0","title":"SauceAnalytics.Store.get_state/0","type":"function"},{"doc":"Increments view_sequence or event_sequence on a session in the Store. type can either be :view or :event","ref":"SauceAnalytics.Store.html#inc_sequence/2","title":"SauceAnalytics.Store.inc_sequence/2","type":"function"},{"doc":"Returns a session in the Store.","ref":"SauceAnalytics.Store.html#lookup_session/1","title":"SauceAnalytics.Store.lookup_session/1","type":"function"},{"doc":"If the session referenced in revive_session does not exist, the session will be revived.","ref":"SauceAnalytics.Store.html#maybe_revive_session/1","title":"SauceAnalytics.Store.maybe_revive_session/1","type":"function"},{"doc":"Creates a new session in the Store.","ref":"SauceAnalytics.Store.html#new_session/2","title":"SauceAnalytics.Store.new_session/2","type":"function"},{"doc":"Revives a previously expired and deleted session in the Store. Given a SauceAnalytics.ReviveSession struct a session can be generated which contains the same session_id that the client expects.","ref":"SauceAnalytics.Store.html#revive_session/1","title":"SauceAnalytics.Store.revive_session/1","type":"function"},{"doc":"Returns true if a session exists in the Store, false otherwise.","ref":"SauceAnalytics.Store.html#session_exists?/1","title":"SauceAnalytics.Store.session_exists?/1","type":"function"},{"doc":"Starts the Store GenServer with the given opts . Use this in your application supervision tree.","ref":"SauceAnalytics.Store.html#start_link/1","title":"SauceAnalytics.Store.start_link/1","type":"function"},{"doc":"","ref":"SauceAnalytics.Store.html#t:opts/0","title":"SauceAnalytics.Store.opts/0","type":"type"},{"doc":"","ref":"SauceAnalytics.Store.html#t:session/0","title":"SauceAnalytics.Store.session/0","type":"type"},{"doc":"This struct represents a session obtained from the Store. Fields :sid - The id of the session. :uid - The id of the user. Can be nil. :user_agent - The user agent of the client's web browser. :view_sequence - The number of times that track_visit has been called. :event_sequence - The number of times that track_event has been called. :last_modified - The unix timestamp of when the session was last modified.","ref":"SauceAnalytics.Store.Session.html","title":"SauceAnalytics.Store.Session","type":"module"},{"doc":"","ref":"SauceAnalytics.Store.Session.html#t:t/0","title":"SauceAnalytics.Store.Session.t/0","type":"type"},{"doc":"The state of the SauceAnalytics.Store GenServer","ref":"SauceAnalytics.Store.State.html","title":"SauceAnalytics.Store.State","type":"module"},{"doc":"","ref":"SauceAnalytics.Store.State.html#t:t/0","title":"SauceAnalytics.Store.State.t/0","type":"type"},{"doc":"TODO: Add description","ref":"readme.html","title":"SauceAnalytics","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding sauce_analytics to your list of dependencies in mix.exs : def deps do [ { :sauce_analytics , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/sauce_analytics .","ref":"readme.html#installation","title":"SauceAnalytics - Installation","type":"extras"}]